﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections;
using Telerik.Windows.Controls.Charting;
using Telerik.Windows.Controls;

namespace SilverlightApplication35_2009Q3SP2
{
    public partial class MainPage : UserControl
    {
        public string GroupedBy { get; set; }
        public string XAxisProperty { get; set; }
        public string YAxisProperty { get; set; }

        public MainPage()
        {
            InitializeComponent();
            this.SetProperties();
            this.SetMappings(RadChart1);
            this.Loaded += new RoutedEventHandler(MainPage_Loaded);
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            RadChart1.DefaultSeriesDefinition = new LineSeriesDefinition();
            RadChart1.ItemsSource = Stock.GetStocks();
        }


        private void SetMappings(RadChart chart)
        {
            SeriesMapping seriesMapping = new SeriesMapping();
            seriesMapping.GroupingSettings.GroupDescriptors.Add(new ChartGroupDescriptor("Name"));
            seriesMapping.SeriesDefinition = new LineSeriesDefinition(); 
            ItemMapping itemMapping = new ItemMapping();
            itemMapping.DataPointMember = DataPointMember.YValue;
            itemMapping.FieldName = "Volume";
            seriesMapping.ItemMappings.Add(itemMapping);
            itemMapping = new ItemMapping();
            itemMapping.DataPointMember = DataPointMember.XCategory;
            itemMapping.FieldName = "Month";
            seriesMapping.ItemMappings.Add(itemMapping);
            chart.SeriesMappings.Add(seriesMapping);

            seriesMapping = new SeriesMapping();
            seriesMapping.GroupingSettings.GroupDescriptors.Add(new ChartGroupDescriptor("Name"));
            seriesMapping.SeriesDefinition = new LineSeriesDefinition();
            itemMapping = new ItemMapping();
            itemMapping.DataPointMember = DataPointMember.YValue;
            itemMapping.FieldName = "Price";
            seriesMapping.ItemMappings.Add(itemMapping);
            itemMapping = new ItemMapping();
            itemMapping.DataPointMember = DataPointMember.XCategory;
            itemMapping.FieldName = "Month";
            seriesMapping.ItemMappings.Add(itemMapping);

            chart.SeriesMappings.Add(seriesMapping);
        }



        private void SetProperties()
        {
            GroupedBy = "Name";
            XAxisProperty = "Month";
            YAxisProperty = "Volume";
        }
    }
    public class Stock
    {
        public string Name { get; set; }
        public string Month { get; set; }
        public double Volume { get; set; }
        public double Price { get; set; }

        public static IEnumerable GetStocks()
        {
            List<Stock> _lstStocks = new List<Stock>();

            Stock s9 = new Stock();
            s9.Name = "Total";
            s9.Month = "JAN";
            s9.Volume = 110;
            s9.Price = 90;

            Stock s10 = new Stock();
            s10.Name = "Total";
            s10.Month = "FEB";
            s10.Volume = 160;
            s10.Price = 125;

            Stock s11 = new Stock();
            s11.Name = "Total";
            s11.Month = "March";
            s11.Volume = 140;
            s11.Price = 150;

            Stock s12 = new Stock();
            s12.Name = "Total";
            s12.Month = "April";
            s12.Volume = 110;
            s12.Price = 97;

            Stock s13 = new Stock();
            s13.Name = "Total";
            s13.Month = "May";
            s13.Volume = 290;
            s13.Price = 210;

            Stock s14 = new Stock();
            s14.Name = "Total";
            s14.Month = "June";
            s14.Volume = 140;
            s14.Price = 185;


            //Institutional  
            Stock s15 = new Stock();
            s15.Name = "Institutional";
            s15.Month = "JAN";
            s15.Volume = 110;
            s15.Price = 90;

            Stock s16 = new Stock();
            s16.Name = "Institutional";
            s16.Month = "FEB";
            s16.Volume = 160;
            s16.Price = 125;

            Stock s17 = new Stock();
            s17.Name = "Institutional";
            s17.Month = "March";
            s17.Volume = 90;
            s17.Price = 150;

            Stock s18 = new Stock();
            s18.Name = "Institutional";
            s18.Month = "April";
            s18.Volume = 145;
            s18.Price = 97;

            Stock s19 = new Stock();
            s19.Name = "Institutional";
            s19.Month = "May";
            s19.Volume = 189;
            s19.Price = 210;

            Stock s20 = new Stock();
            s20.Name = "Institutional";
            s20.Month = "June";
            s20.Volume = 120;
            s20.Price = 185;


            //For Total  
            _lstStocks.Add(s9);
            _lstStocks.Add(s10);
            _lstStocks.Add(s11);
            _lstStocks.Add(s12);
            _lstStocks.Add(s13);
            _lstStocks.Add(s14);

            //for institutional  
            _lstStocks.Add(s15);
            _lstStocks.Add(s16);
            _lstStocks.Add(s17);
            _lstStocks.Add(s18);
            _lstStocks.Add(s19);
            _lstStocks.Add(s20);


            return _lstStocks as IEnumerable;
        }

        public static List<Stock> GetStocksWithIndexList()
        {

            List<List<Stock>> _indexList = new List<List<Stock>>();
            List<Stock> _lstStocks = new List<Stock>();

            Stock s9 = new Stock();
            s9.Name = "Total";
            s9.Month = "JAN";
            s9.Volume = 110;
            s9.Price = 90;

            Stock s10 = new Stock();
            s10.Name = "Total";
            s10.Month = "FEB";
            s10.Volume = 160;
            s10.Price = 125;

            Stock s11 = new Stock();
            s11.Name = "Total";
            s11.Month = "March";
            s11.Volume = 140;
            s11.Price = 150;

            Stock s12 = new Stock();
            s12.Name = "Total";
            s12.Month = "April";
            s12.Volume = 110;
            s12.Price = 97;

            Stock s13 = new Stock();
            s13.Name = "Total";
            s13.Month = "May";
            s13.Volume = 290;
            s13.Price = 210;

            Stock s14 = new Stock();
            s14.Name = "Total";
            s14.Month = "June";
            s14.Volume = 140;
            s14.Price = 185;


            //Institutional  
            Stock s15 = new Stock();
            s15.Name = "Institutional";
            s15.Month = "JAN";
            s15.Volume = 110;
            s15.Price = 90;

            Stock s16 = new Stock();
            s16.Name = "Institutional";
            s16.Month = "FEB";
            s16.Volume = 160;
            s16.Price = 125;

            Stock s17 = new Stock();
            s17.Name = "Institutional";
            s17.Month = "March";
            s17.Volume = 90;
            s17.Price = 150;

            Stock s18 = new Stock();
            s18.Name = "Institutional";
            s18.Month = "April";
            s18.Volume = 145;
            s18.Price = 97;

            Stock s19 = new Stock();
            s19.Name = "Institutional";
            s19.Month = "May";
            s19.Volume = 189;
            s19.Price = 210;

            Stock s20 = new Stock();
            s20.Name = "Institutional";
            s20.Month = "June";
            s20.Volume = 120;
            s20.Price = 185;


            //For Total  
            _lstStocks.Add(s9);
            _lstStocks.Add(s11);
            _lstStocks.Add(s12);
            _lstStocks.Add(s13);
            _lstStocks.Add(s14);

            //for institutional  
            _lstStocks.Add(s15);
            _lstStocks.Add(s16);
            _lstStocks.Add(s17);
            _lstStocks.Add(s18);
            _lstStocks.Add(s19);
            _lstStocks.Add(s20);

            _indexList.Add(_lstStocks);
            //_indexList.Add(_lstStocks);  

            return _lstStocks;
        }
    }
}
